/* bitmap.h version 2.1.2 */
#ifndef __MY_BITMAP_H__
#define __MY_BITMAP_H__

#include <stdio.h>

#ifndef RGB
#define RGB(_r,_g,_b)		{ (_b), (_g), (_r), 0x00 }
#endif

#ifndef RGBA
#define RGBA(_r,_g,_b,_a)	{ (_b), (_g), (_r), (_a) }
#endif

struct bitmap_header_t {
	unsigned int file_length;
	unsigned short reserved1;		/* 0x0000 */
	unsigned short reserved2;		/* 0x0000 */
	unsigned int offset_bitmap;
	unsigned int header_size;		/* 40 */
	unsigned int width;
	unsigned int height;
	unsigned short planes;
	unsigned short bit_count;
	unsigned int compression;		/* 0 */
	unsigned int data_length;
	unsigned int h_resolution;		/* 0x00000000 *//* pixel/meter */
	unsigned int v_resolution;		/* 0x00000000 *//* pixel/meter */
	unsigned int used_colors;		/* 0x00000000 */
	unsigned int important_colors;	/* 0x00000000 */
};

struct bitmap_palette_t {
	unsigned char blue;
	unsigned char green;
	unsigned char red;
	unsigned char alpha;
};

extern int create_bitmap_header(struct bitmap_header_t *header, unsigned int width, unsigned int height, unsigned short bit_count);
extern int write_bitmap(FILE *fp, const struct bitmap_header_t *header, const struct bitmap_palette_t *palette, const unsigned char *data);
extern int read_bitmap_header(FILE *fp, struct bitmap_header_t *header);
extern int read_bitmap(FILE *fp, struct bitmap_header_t *header, struct bitmap_palette_t **palette, unsigned char **data, int header_already_read);
extern int find_palette_best_match(int red, int green, int blue, const struct bitmap_palette_t *palette, int count);
extern int convert_bit_count(int width, int height, int src_bit_count, const struct bitmap_palette_t *src_palette, const unsigned char *src_data, int des_bit_count, const struct bitmap_palette_t *des_palette, unsigned char **des_data);

#endif	/* __MY_BITMAP_H__ */
